<?php
/**
 * @package Plugin rkWWWredirect for Joomla! 3.0
 * @version v1.0
 * @author Maik Wuerth
 * @copyright (C) 2018- Maik Wuerth
 * @license GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
**/

defined( '_JEXEC' ) or die;

class plgSystemRkwwwredirect extends JPlugin
{

	protected $autoloadLanguage = true;

	function onAfterRoute()
	{
		//get parameters
		$dowww = (int)$this->params->get('redirect_www', 1);
		$where = (int)$this->params->get('redirect_site', 0);
		//#get uri and parts of url
		$uri = JUri::getInstance();
		$url = rawurldecode($uri->toString(array('scheme','host', 'port', 'path', 'query', 'fragment')));
		$rest = rawurldecode($uri->toString(array('port', 'path', 'query', 'fragment')));
		$orgscheme = $uri->getScheme();
		$orghost = $uri->getHost();
		$orgpath = $uri->getPath();

		//check if backend
		if(strpos($orgpath,'administrator')) {
			$backend = true;
		} else {
			$backend = false;
		}

		//check if localhost
		if(strpos($url, 'localhost') || strpos($url, '127.0.0.1')) {
			$local = true;
		} else {
			$localhost = false;
		}

		//if redirect wanted and not accessed through localhost
		if($dowww && !$localhost) {
			//check how page is accessed and check against parameter
			if( (!$backend && ($where == 2)) || ($backend && ($where == 3)) || ($where == 1) ) {
				//check url for missing www
				if(substr($orghost,0,4) != 'www.') {
					//add www to url
					$newurl = $orgscheme . '://www.' . $orghost . $rest;
					header("Location:".$newurl, true, 301);
					exit;
				}
			}
			return true;
		}
	}
}
?>
